package sk.upjs.ics.currencr.test;

import java.math.BigDecimal;

import sk.upjs.ics.currencr.EuroCurrencyConverter;
import junit.framework.Assert;
import junit.framework.TestCase;

public class EuroCurrencyConverterTest extends TestCase {
	
	private EuroCurrencyConverter currencyConverter;

	@Override
	protected void setUp() throws Exception {
		super.setUp();
		
		currencyConverter = new EuroCurrencyConverter();
	}
	
	public void testConvert() throws Exception {
		Assert.assertEquals(new BigDecimal("131.1900"), currencyConverter.convert("USD", new BigDecimal(100)));
		Assert.assertEquals(new BigDecimal("2594.200"), currencyConverter.convert("CZK", new BigDecimal(100)));
	} 
	
	public void testUnsupportedCurrencyCode() throws Exception {
		Assert.assertFalse(currencyConverter.supportsCurrency("XYZ"));
	}	

	public void testSupportsCurrency() throws Exception {
		currencyConverter.supportsCurrency("USD");
	}
	
	public void testConvertUnsupportedCurrency() throws Exception {
		try {
			String weirdCurrencyCode = "XXX";
			currencyConverter.convert(weirdCurrencyCode, BigDecimal.TEN);
			fail("Conversion of '" + weirdCurrencyCode + "' failed");
		} catch (IllegalArgumentException e) {
			// this is expected behaviour
		}
	}	
}
