package sk.upjs.ics.currencr.test;

import sk.upjs.ics.currencr.MainActivity;
import sk.upjs.ics.currencr.R;
import android.test.ActivityInstrumentationTestCase2;
import android.view.KeyEvent;
import android.view.View;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;

public class MainActivityTest extends
		ActivityInstrumentationTestCase2<MainActivity> {


	private EditText amountEditText;
	private Spinner currencySpinner;
	private TextView resultTextView;

	public MainActivityTest() {
		super(MainActivity.class);
	}

	@Override
	protected void setUp() throws Exception {
		super.setUp();
		setActivityInitialTouchMode(false);

		amountEditText = (EditText) findViewById(R.id.amountEditText);
		currencySpinner = (Spinner) findViewById(R.id.currencySpinner);
		
		resultTextView = (TextView) findViewById(R.id.resultTextView);

	}
	
	public void testCZK() {
		requestFocus(amountEditText);
		sendKeys(KeyEvent.KEYCODE_DPAD_RIGHT, KeyEvent.KEYCODE_DPAD_RIGHT);
		sendKeys(KeyEvent.KEYCODE_DEL, KeyEvent.KEYCODE_DEL, KeyEvent.KEYCODE_DEL);
		sendKeys(KeyEvent.KEYCODE_1, KeyEvent.KEYCODE_0, KeyEvent.KEYCODE_0, KeyEvent.KEYCODE_DPAD_CENTER);
		requestFocus(currencySpinner);

		sendKeys(KeyEvent.KEYCODE_DPAD_CENTER);
		// move to 'CZK'
		sendKeys(KeyEvent.KEYCODE_DPAD_DOWN);
		// confirm 'CZK'
		sendKeys(KeyEvent.KEYCODE_DPAD_CENTER);
		
		assertEquals("2594.20", resultTextView.getText().toString());
	}

	private void requestFocus(final View view) {
		getActivity().runOnUiThread(new Runnable() {
			@Override
			public void run() {
				view.requestFocus();
			}
		});
		getInstrumentation().waitForIdleSync();
	}
	
	private View findViewById(int id) {
		return getActivity().findViewById(id);
	}
}
