package sk.upjs.ics.currencr;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

public class EuroCurrencyConverter {
	private Map<String, BigDecimal> currencyRatios = new HashMap<String, BigDecimal>();

	public EuroCurrencyConverter() {
		currencyRatios.put("USD", new BigDecimal("1.3119"));
		currencyRatios.put("CZK", new BigDecimal("25.942"));
		currencyRatios.put("HUF", new BigDecimal("297.79"));
		currencyRatios.put("PLN", new BigDecimal("4.1124"));
	}
	
	public BigDecimal convert(String currencyCode, BigDecimal amount) {
		if(!supportsCurrency(currencyCode)) {
			throw new IllegalArgumentException("Currency code '" + currencyCode + "' is not supported");
		}
		BigDecimal ratio = currencyRatios.get(currencyCode);
		return ratio.multiply(amount);
	}
	
	public boolean supportsCurrency(String currencyCode) {
		return currencyRatios.containsKey(currencyCode);
	}
}
